Package: SIMD
Type: Package
Title: Statistical Inferences with MeDIP-seq Data (SIMD) to infer the
        methylation level for each CpG site
Version: 1.31.0
Author: Yan Zhou
Maintainer: Jiadi Zhu <2160090406@email.szu.edu.cn>
Description: This package provides a inferential analysis method 
    for detecting differentially expressed CpG sites in MeDIP-seq data. It uses 
    statistical framework and EM algorithm, to identify differentially expressed 
    CpG sites. The methods on this package are described in the article 
    'Methylation-level Inferences and Detection of Differential Methylation 
    with Medip-seq Data' by Yan Zhou, Jiadi Zhu, Mingtao Zhao, Baoxue Zhang, 
    Chunfu Jiang and Xiyan Yang (2018, pending publication).
License: GPL-3
Encoding: UTF-8
LazyData: true
Depends: R (>= 3.5.0)
Imports: edgeR, statmod, methylMnM, stats, utils
Suggests: BiocStyle, knitr,rmarkdown
biocViews: ImmunoOncology, DifferentialMethylation,SingleCell,
        DifferentialExpression
VignetteBuilder: knitr
RoxygenNote: 6.0.1
git_url: https://git.bioconductor.org/packages/SIMD
git_branch: devel
git_last_commit: 3d3c8d5
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: yes
Packaged: 2026-04-29 01:08:14 UTC; biocbuild

# SIMD-package
This package use Statistical Inferences with MeDIP-seq Data (SIMD) to infer the 
methylation level for each CpG site. The methods on this package are described 
in the article 'Methylation-level Inferences and Detection of Differential 
Methylation with Medip-seq Data'[1]. 

# Introduction
DNA methylation is an essential epigenetic modification involved in regulating 
the expression of mammalian genomes. A variety of experimental approaches to 
generate genome-wide or whole-genome DNA methylation data have emerged in 
recent years. Methylated DNA immunoprecipitation followed by sequencing 
(MeDIP-seq) is one of the major tools used in whole-genome epigenetic studies. 
However, analyzing this data in terms of accuracy, sensitivity, and speed still 
remains an important challenge. Existing methods, such as BATMAN[2] and MEDIPS[3], 
analyze MeDIP-seq data by dividing the whole genome into equal length windows 
and assume that each CpG of the same window has the same methylation level. 
More precise work is necessary to estimate the methylation level of each CpG 
site in the whole genome. In this paper, we propose a Statistical Inferences 
with MeDIP-seq Data (SIMD) to infer the methylation level for each CpG site. 
This package provides a inferential analysis method for detecting differentially 
expressed CpG sites in MeDIP-seq data. It uses statistical framework and EM 
algorithm, to identify differentially expressed CpG sites.

# User's Guide
Please refer to the "SIMD.pdf" vignetee for detailed function 
instructions.

# Reference
1. Zhou Y, Zhu JD, Zhao MT, Zhang Bx, Jiang CF, and Yang XY. "Methylation-level 
Inferences and Detection of Differential Methylation with Medip-seq Data". 
Plos one. Accepted.
2. Down TA, Rakyan VK, Turner DJ, Flicek P, Li H, Kulesha E, et al. "A Bayesian
deconvolution strategy for immunoprecipitation-based DNA methylome analysis".
Nature Biotechnology. 2008; 26: 779-785.
3. Chavez L, Jozefczuk J, Grimm C, Dietrich J, Timmermann B, Lehrach H, et al.
"Computational analysis of genome-wide DNA methylation during the
differentiation of human embryonic stem cells along the endodermal lineage".
Genome Research. 2010; 20: 1441-1450.
[![Travis-CI Build Status](https://travis-ci.org/FocusPaka/SIMD.svg?branch=master)](https://travis-ci.org/FocusPaka/SIMD)

#sum>=1
#' Calculate the probability on condition that the sums more than 1.
#' 
#' @description Calculate the probability on condition that at least a CpG 
#' contributes to a short read.
#' @param X A matrix about X, the elements in X takes values on {0,1} and
#' satisfy the sums of each row more than 1.
#' @return y1 The probability when sums more than 1.
#' @examples 
#' set.seed(123)
#' d <- matrix(0, nrow=200, ncol=50)
#' random_num <- sample(1:10, 200, replace=TRUE)
#' for(i in 1:nrow(d)){
#'     temp <- sample(1:50, random_num[i], replace=FALSE)
#'     d[i,temp] <- 1
#' }
#' result <- emalgth1(d)
#' head(result)
#' @export



emalgth1 <- function(X)
{
    N <- colSums(X)/length(X[, 1])
    p <- 1-N
    p1 <- 1-prod(p)
    N <- N*p1
    y <- X
    for(i in seq_len(length(N))){
        y[y[, i]!=0,i] <- N[i]
    }
    N1 <- 1-y
    N2 <- apply(N1, 1, prod)
    CpGnum <- rep(1, length(X[1, ]))
    N11 <- 1-N2 %o% CpGnum
    y1 <- y/N11
    return(y1)
}

## ----eval=FALSE---------------------------------------------------------------
# install.packages("BiocManager")
# BiocManager::install(c('edgeR', 'statmod','methylMnM'))
# 
# library(edgeR)
# library(statmod)
# library(methylMnM)

## ----eval=FALSE---------------------------------------------------------------
# BiocManager::install("SIMD")

## -----------------------------------------------------------------------------
library(SIMD)

## -----------------------------------------------------------------------------
datafile <- system.file("extdata", package="methylMnM")
filepath <- datafile[1]

## -----------------------------------------------------------------------------
dirwrite <- paste(setwd(getwd()), "/", sep="")

## -----------------------------------------------------------------------------
data(example_data)
allcpgfile <- EM_H1ESB1_MeDIP_sigleCpG
readshort <- paste(filepath, "/H1ESB1_MeDIP_18.extended.txt", sep="")
writefile <- paste(dirwrite, "EM2_H1ESB1_MeDIP_sigleCpG.bed", sep="")
reportfile <- paste(dirwrite, "EM2_H1ESB1_MeDIP_sigleCpG_report.bed", sep="")
EMalgorithm(cpgsitefile=readshort, allcpgfile=allcpgfile, category="1",
            writefile=writefile, reportfile=reportfile)

## -----------------------------------------------------------------------------
data(example_data)
data1 <- EM2_H1ESB1_MeDIP_sigleCpG
data2 <- EM2_H1ESB2_MeDIP_sigleCpG
data3 <- H1ESB1_MRE_sigleCpG
data4 <- H1ESB2_MRE_sigleCpG
datafile <- cbind(data1,data2,data3,data4)
allcpg <- all_CpGsite_bin_chr18
mrecpg <- three_mre_cpg
dirwrite <-paste(setwd(getwd()), "/", sep="")

writefile <- paste(dirwrite, "pval_EM_H1ESB1_H1ESB21.bed", sep="")
reportfile <- paste(dirwrite, "report_pvalH1ESB1_H1ESB21.bed", sep="")

EMtest(datafile=datafile, chrstring=NULL, cpgfile=allcpg,mrecpgfile=mrecpg, 
       writefile=writefile, reportfile=reportfile,mreratio=3/7, psd=2, 
       mkadded=1, f=1)

#' Compute P-values for Medip-seq and MRE-seq data.
#'
#' @description Compute P-values.
#' @param t The real value for random variable according to dataset.
#' @param size1 The sum of Medip-seq real reads of the each CpG site for
#' control and treatment sample.
#' @param size2 The sum of MRE-seq real reads of the each CpG site for control
#' and treatment sample.
#' @param c1 The scaling factor for MeDip-seq data.
#' @param c2 The scaling factor for MRE-seq data.
#' @return p The P-values for testing the methylation expression levels for each
#' CpG sites.
#' @examples 
#' set.seed(1234)
#' t <- 0.1
#' size1 <- sample(1:1000, 1, replace=TRUE)
#' size2 <- sample(1:1000, 1, replace=TRUE)
#' c1 <- 1
#' c2 <- 2
#' result <- probBinom(t, size1, size2, c1, c2)
#' @export


probBinom <- function(t, size1, size2, c1, c2){
    prob1 <- 1/(1 + c1)
    prob2 <- 1/(1 + c2)
    i <- 0:size1
    j <- size1:0
    pij <- dbinom(i, prob=prob1, size=size1)
    r <- 0:size2
    k <- size2:0
    prk <- dbinom(r, prob=prob2, size=size2)
    ik <- outer(i, k)
    jr <- outer(j, r)
    ijrk <- c1*ik-c2*jr
    prob <- outer(pij, prk)
    ir <- which(abs(ijrk)>=t, arr.ind=TRUE)
    p <- sum(prob[ir])
    return(p)
}

#(2) EM algorithm
#' EM algorithm to infer CpG sites.
#' 
#' @description Using EM algorithm to infer the real number of CpG sites.
#' @param cpgsitefile The path of file to store CpG site.
#' @param allcpgfile The file to store CpG sites.
#' @param category Default to "1".
#' @param writefile The path of output results. (If writefile=NULL, there will
#' return the results back to main program.)
#' @param reportfile The path of output results.
#' @return values or file If writefile is NULL, then return the values of
#' results,otherwise output to write file.
#' @examples 
#' datafile <- system.file("extdata", package="methylMnM")
#' data(example_data)
#' filepath <- datafile[1]
#' allcpgfile <- EM_H1ESB1_MeDIP_sigleCpG
#' dirwrite <- paste(setwd(getwd()), "/", sep="")
#' readshort <- paste(filepath, "/H1ESB1_MeDIP_18.extended.txt", sep="")
#' writefile <- paste(dirwrite, "EM2_H1ESB1_MeDIP_sigleCpG.bed", sep="")
#' reportfile <- paste(dirwrite, "EM2_H1ESB1_MeDIP_sigleCpG_report.bed", sep="")
#' f <- EMalgorithm(cpgsitefile=readshort, allcpgfile=allcpgfile, category="1",
#'                  writefile=writefile, reportfile=reportfile)
#' @export

EMalgorithm <- function(cpgsitefile, allcpgfile, category="1",
                        writefile=NULL, reportfile=NULL){
    w <- proc.time()
    if (is.null(allcpgfile)) {
        print("NO CpG sites file")
    } else {
        allcpg <- allcpgfile
    }
    if (is.null(cpgsitefile)) print("Error, No cpgsitefile")
    nrec <- length(count.fields(cpgsitefile))
    
    readcpgsite <- function(skip, nrows) {
        read.table(cpgsitefile, header = FALSE, skip = skip, nrows=nrows, 
            as.is = TRUE)
    }
    tag_cpg1 <- readcpgsite(0, floor(nrec/4))
    tag_cpg2 <- readcpgsite(floor(nrec/4), floor(nrec/4))
    tag_cpg3 <- readcpgsite(2*floor(nrec/4), floor(nrec/4))
    tag_cpg4 <- readcpgsite(3*floor(nrec/4), nrec)

    if (is.null(allcpg)) {
        chrtype1 <- unique(tag_cpg1[, 1])
        chrtype2 <- unique(tag_cpg2[, 1])
        chrtype3 <- unique(tag_cpg3[, 1])
        chrtype4 <- unique(tag_cpg4[, 1])
        chrstring <- unique(c(chrtype1, chrtype2, chrtype3, chrtype4))
    } else {
        chrstring <- unique(allcpg[, 1])
    }
    chrsizes <- length(chrstring)
    cpg <- matrix(0, 2, 4)
    for (i in seq_len(chrsizes)) {
        xx141 <- tag_cpg1[tag_cpg1[, 1] == chrstring[i], ]
        xx142 <- tag_cpg2[tag_cpg2[, 1] == chrstring[i], ]
        xx143 <- tag_cpg3[tag_cpg3[, 1] == chrstring[i], ]
        xx144 <- tag_cpg4[tag_cpg4[, 1] == chrstring[i], ]
        tag_cpgchr19 <- rbind(xx141, xx142, xx143, xx144)
        tag_cpgchr19 <- tag_cpgchr19[order(tag_cpgchr19[, 2]), ]
        cpg19 <- allcpg[allcpg[, 1] == chrstring[i], ]
        cpg19 <- cpg19[order(cpg19[, 2]), ]
        cpg20 <- cpg19
        cpg20[, 4] <- 0
        zero <- cpg19[cpg19[, 4]==0, ]

        slid <- length(zero[, 1])
        for (j in seq_len(slid)) {
        if (j == 1) {
            region <- cpg19[cpg19[, 2] < zero[j, 2], ]
        } else {
            if (j == slid) {
                region <- cpg19[cpg19[, 2] > zero[j, 2], ]
            } else {
                region <- cpg19[cpg19[, 2] > zero[(j-1), 2]&
                                cpg19[, 2] < zero[j, 2], ]
            }
        }
        num <- length(region[, 1])
        if (num != 0) {
        regiontag <- tag_cpgchr19[tag_cpgchr19[, 2] < region[num, 3]&
        tag_cpgchr19[, 3] > region[1, 2], seq_len(3)]
        tagm <- matrix(0, length(regiontag[, 1]), num)
        for(r in seq_len(length(regiontag[, 1]))){
            tagm[r, region[, 2] >= regiontag[r, 2]&
            region[, 2] < regiontag[r, 3]] <- 1
        }
        tagm <- tagm[rowSums(tagm) != 0, ]
        X1 <- tagm + 3
        Y <- tagm

        if (category == "1") {
            while(max(abs(X1-Y)) > 1e-6){
            X1 <- Y
            if(is.matrix(tagm)){
                Y <- emalgth(tagm)
            }
            }
        } else {
            while(max(abs(X1 - Y)) > 1e-6){
            X1 <- Y
            if(is.matrix(tagm)){
                Y <- emalgth1(tagm)
            }
            }
        }

        if(is.matrix(tagm)){
            realnum <- colSums(Y)
        } else {
            if (num == 1) {
            realnum <- sum(Y)
            } else {
            realnum <- Y
            }
        }

        if (j == 1) {
            cpg20[cpg19[, 2] < zero[j, 2], 4] <- realnum
        } else {
            if (j == slid) {
            cpg20[cpg19[, 2] > zero[j, 2], 4] <- realnum
            } else {
            cpg20[cpg19[, 2] > zero[(j-1), 2]&
            cpg19[, 2] < zero[j, 2], 4] <- realnum
            }
        }
        }
        if (j %% 10000==0) print(j)
    }
    print(i)
    }

    d <- proc.time()
    time <- d-w
    if (!is.null(reportfile)) {
        str <- paste("Number of CpG sites:", length(cpg20[, 4]),
                     "\n",
                     "Total count of all CpG sites before EM algorithm:", 
                     sum(cpg19[, 4]),
                     "\n",
                     "Total count of all CpG sites after EM algorithm:", 
                     sum(cpg20[, 4]),
                     "\n",
                     "Spend time:", time)
        write(str, reportfile)
    }

    if (!is.null(writefile)) 
        write.table(cpg20, writefile, sep="\t", quote=FALSE, row.names=FALSE)
    return(cpg20)
    
}

#sum=1
#' Calculate the probability on condition that the sums equal to 1.
#' @description Calculate the probability on condition that only a single CpG 
#' contributes to a short read. 
#' @param X A matrix about X, the elements in X takes values on {0,1} and
#' satisfy the sums of each row equal to 1.
#' @return y1 The probability when sums equal to 1.
#' @examples 
#' set.seed(123)
#' d <- matrix(0, nrow=200, ncol=50)
#' random_num <- sample(1:50, 200, replace=TRUE)
#' for(i in 1:nrow(d)){
#'     d[i,random_num[i]]<-1
#' }
#' result <- emalgth(d)
#' head(result)
#' @export

emalgth <- function(X)
{
    N <- colSums(X)
    y <- X
    for(i in seq_len(length(N))){
        y[y[, i]!=0, i] <- N[i]
    }
    N1 <- rowSums(y)
    CpGnum <- rep(1, length(X[1, ]))
    N11 <- N1 %o% CpGnum
    y1 <- y/N11
    return(y1)
}

#' calculate P-value in code EMtest.
#'
#' @param type1 The first colum of the first matrix.
#' @param type2 The second colum of the first matrix.
#' @param type3 The third colum of the first matrix.
#' @param type4 The fourth colum of the first matrix.
#' @param sm1chring1 The first colum of the second matrix.
#' @param sm1chring2 The second colum of the second matrix.
#' @param sm1chring3 The third colum of the second matrix.
#' @param sm1chring4 The forth colum of the second matrix.
#' @param p P-value.
#' @param typelength The nrows of the first matrix.
#' @param sm1chringlength The nrows of the second matrix.
#' @param pvalue A vector, the length equals to the nrows of the second matrix.
#' @return The probability.
#' @keywords internal
#' @useDynLib SIMD pvalueclassify

classifypvalue <- function(type1, type2, type3, type4, 
                           sm1chring1, sm1chring2, sm1chring3, 
                           sm1chring4, p, typelength, sm1chringlength,
                           pvalue=rep(0,length(sm1chring1))){
    problity <- .C("pvalueclassify", as.integer(type1), 
                   as.integer(type2), as.integer(type3), 
                   as.integer(type4), as.integer(sm1chring1),
                   as.integer(sm1chring2), as.integer(sm1chring3), 
                   as.integer(sm1chring4), as.double(p), 
                   as.integer(typelength), as.integer(sm1chringlength),
                   as.double(pvalue))
    return(problity[[12]])
}

.onUnload <- function (libpath) {library.dynam.unload("SIMD", libpath)}

#' Inferring the methylation expression level of single sites.
#' 
#' @description Using statistical framework and EM algorithm to infer the
#' methylation expression level of single sites.
#' @param datafile The files of sample. (datafile should be cbind(data1,data2,
#' data3,data4), where data1 and data2 are Medip-seq data, data3 and data4 are
#' MRE-seq data).
#' @param chrstring The chromosome should be test.
#' @param cpgfile The file of all CpG number.
#' @param mrecpgfile The file of MRE-CpG number(If NULL, mrecpgfile will equal
#' to cpgfile).
#' @param writefile The path of file of output result. (If writefile=NULL,
#' there will return the results back to main program)
#' @param reportfile The path of output results of the number of bin, total
#' reads before processing and total reads after processing.
#' @param mreratio The ratio of total unmethylation level with total
#' methylation level (Defaulted mreratio is 3/7).
#' @param psd The parameters of pseudo count, which pseudo count added to
#' Medip-seq and MRE-seq count.
#' @param mkadded Added to all CpG and MRE CpG (We set psd=2 and mkadded=1 as
#' defaulted for robust).
#' @param f Adjustment weight, default to 1.
#' @return values or file The output file "writefile" will own eleven columns,
#' that is, "chr", "chrSt", "chrEnd", "Medip1", "Medip2", "MRE1", "MRE2",
#' "cg","mrecg","pvalue" and "Ts". We also output a report file which will
#' include parameters "s1/s2", "s3/s4", "N1", "N2", "N3", "N4", "c1",
#' "c2", "Number of windows" and "Spend time".
#' @examples data(example_data)
#' data1 <- EM2_H1ESB1_MeDIP_sigleCpG
#' data2 <- EM2_H1ESB2_MeDIP_sigleCpG
#' data3 <- H1ESB1_MRE_sigleCpG
#' data4 <- H1ESB2_MRE_sigleCpG
#' datafile <- cbind(data1, data2, data3, data4)
#' allcpg <- all_CpGsite_bin_chr18
#' mrecpg <- three_mre_cpg
#' dirwrite <- paste(setwd(getwd()), "/", sep="")
#' writefile <- paste(dirwrite, "pval_EM_H1ESB1_H1ESB21.bed", sep="")
#' reportfile <- paste(dirwrite, "report_pvalH1ESB1_H1ESB21.bed", sep="")
#' EMtest(datafile=datafile, chrstring=NULL, cpgfile=allcpg,
#'        mrecpgfile=mrecpg, writefile=writefile, reportfile=reportfile,
#'        mreratio=3/7, psd=2, mkadded=1, f=1)
#' @export



EMtest <- function(datafile=NULL, chrstring=NULL, cpgfile, 
                   mrecpgfile=NULL,writefile=NULL, reportfile=NULL,
                   mreratio=3/7, psd=2, mkadded=1, f=1){
    
    starttime <- proc.time()
    message("reading data ....")
    if (length(datafile) == 2) {
        message("The datafile is only Medip-seq data")
        data1 <- datafile[1]
        data2 <- datafile[2]
        data3 <- data1
        data4 <- data2
        data3[, 4] <- 0
        data4[, 4] <- 0
    } else {
    if (length(datafile)!=8 & length(datafile)!=16) {
        stop("The input MeDIP and MRE file should be two or four files")
    }
    data1 <- datafile[, seq_len(4)]
    data2 <- datafile[, seq(5, 8)]
    data3 <- datafile[, seq(9, 12)]
    data4 <- datafile[, seq(13, 16)]
    }
    
    dataset <- cbind(data1, data2[, 4], data3[, 4], data4[, 4])
    if (is.null(f)) f <- 1
    message("adjustment weight f is :")
    print(f)
    if (f == 0) stop("f should larger than 0")
    message("Top line of dataset:")
    print(dataset[1, ])
    dataset[, 4:7] <-  dataset[,4:7]/f
    colnames(dataset) <- c("V1","V2","V3","V4","V5","V6","V7")
    if (is.null(cpgfile)) {
        stop(" No CpG file")
    } else {
        cpg <- cpgfile
        print(cpg[1, ])
    }
    if (is.null(mrecpgfile)) {
        mrecpg <- cpg
        message("warning: MRE-CpG file is same as CpG file")
    } else {
        mrecpg <- mrecpgfile
        print(mrecpg[1, ])
    }
    cpg[, 4] <- cpg[, 4]/f
    mrecpg[, 4] <- mrecpg[, 4]/f
    
    if (is.null(mkadded)) mkadded <- 1
    cpg[mrecpg[,4] != 0, 4] <- cpg[mrecpg[, 4] != 0, 4] + mkadded
    mrecpg[mrecpg[, 4] != 0, 4] <- mrecpg[mrecpg[, 4] != 0, 4] + mkadded
    newdata <- dataset
    newdata[mrecpg[,4] != 0, 6:7] <- newdata[mrecpg[,4] != 0, 6:7]*
    (cpg[mrecpg[, 4] != 0, 4]/mrecpg[mrecpg[, 4] != 0, 4])
    NN1 <- sum(dataset[, 4])
    NN2 <- sum(dataset[, 5])
    NN3 <- sum(dataset[, 6])*(sum(cpg[, 4])/sum(mrecpg[, 4]))
    NN4 <- sum(dataset[, 7])*(sum(cpg[, 4])/sum(mrecpg[, 4]))
    if (mreratio >= 0) {
        if (NN3 == 0){
            cc1 <- 1
        } else {
            cc1 <- (NN1/NN3)*mreratio}
        if(NN4 == 0){
            cc2 <- 1
        } else {
            cc2 <- (NN2/NN4)*mreratio}
        } else {
            cc1 <- 1
            cc2 <- 1
    }
    newdata[, 6] <- round(newdata[, 6]*cc1)
    newdata[, 7] <- round(newdata[, 7]*cc2)
    dataset <- newdata

    if (is.null(psd)) psd <- 1
    dataset[mrecpg[, 4] != 0, 4:7] <- round(dataset[mrecpg[, 4] != 0, 4:7]+psd)
    dataset[mrecpg[,4] == 0, 4:5] <- round(dataset[mrecpg[, 4]==0, 4:5]+psd)
    Medip <- dataset[, 4:5]
    Medip <- as.matrix(Medip)
    fws1s2 <- edgeR::calcNormFactors(Medip, logratioTrim=0.05, sumTrim=0.05)[2]
    mre <- dataset[rowSums(dataset[, 6:7]) != 2*round(psd) & mrecpg[, 4]!=0,6:7]
    if (length(mre[, 1]) == 0){
        fws3s4 <- 1
    } else {
        mre <- as.matrix(mre)
        mno2 <- cpg[rowSums(dataset[, 6:7]) != 2*round(psd) & mrecpg[, 4]!=0,4]
        kno2 <- mrecpg[rowSums(dataset[, 6:7]) != 2*round(psd)& mrecpg[,4]!=0,4]
        fws3s4 <- edgeR::calcNormFactors(mre,logratioTrim=0.05, sumTrim=0.05)[2]
    }
    
    if (is.null(chrstring)){
        sm <- as.matrix(dataset[, 4:7])
        cpg <- cpg
        kk <- mrecpg
    } else {
        sm <- as.matrix(dataset[dataset[, 1] == chrstring, 4:7])
        cpg <- cpg[cpg[, 1] == chrstring, ]
        kk <- mrecpg[mrecpg[, 1] == chrstring, ]
    if (length(sm[, 1]) == 0) print("No such chrstring data")
    }
    pall <- rep(0, length(sm[, 1]))
    if(length(datafile) == 2) {
        message("Compute all p-values with SAGE.test")
        kk[, 4] <- 0
    }

    medipct <- sm[kk[, 4] == 0, seq_len(2)]
    cpgS = cpg[kk[, 4] == 0, 4] 
    message(paste("Computing p-values for only MeDIP-seq windows:",
    length(medipct[, 1])))
    pmedip <- statmod::sage.test(medipct[, 1], medipct[, 2],
    n1=sum(medipct[, 1])/sqrt(fws1s2), n2=sum(medipct[, 2])*sqrt(fws1s2))
    pall[kk[, 4] == 0] <- pmedip
    ts <- cpg[, 4]
    ns1 <- round(sum(medipct[, 1])/sqrt(fws1s2))
    ns2 <- round(sum(medipct[, 2])*sqrt(fws1s2))
    probs <- ns1/(ns1+ns2)
    cs <- fws1s2*(sum(medipct[, 2])/sum(medipct[, 1]))
    tts1 <- cpg[kk[, 4] == 0, 4]
    nn <- rowSums(medipct)
    tts1[nn == 0] <- 0

    tts1[nn != 0] <- sqrt(nn[nn != 0])*((cs*medipct[nn != 0, 1]/
    nn[nn != 0]-medipct[nn != 0, 2]/nn[nn != 0])-((cs+1)*probs-1))/
    (sqrt(probs*(1-probs))*(1+cs))
    ts[kk[, 4] == 0] <- tts1

    if(length(cpg[kk[, 4] != 0, 1]) != 0){
        cpg4 <- cpg[kk[, 4]!=0, ]
        sm1 <- sm[kk[, 4] != 0, ]
        kk1 <- kk[kk[, 4] != 0, ]
        m <- cpg4[, 4]
        k <- kk1[, 4]
        message(paste("Computing p-values for MeDIP-seq
                    and MRE-seq windows:", length(m)))
        sm1 <- round(sm1)
        x1 <- sm1[, 1]  
        x2 <- sm1[, 2]  
        y1 <- sm1[, 3]  
        y2 <- sm1[, 4]  

        N1 <- sum(x1)
        N2 <- sum(x2)
        N3 <- sum(y1)
        N4 <- sum(y2)
        rmd21 <- fws1s2*(N2/N1)
        rmd43 <- fws3s4*(N4/N3)

        tt <- abs(rmd21*x1*y2 - rmd43*x2*y1)
        size <- round(rowSums(sm1))
        tts3 <- (rmd21*x1*y2 - rmd43*x2*y1)/(size^2+0.1)

        ts[kk[, 4] != 0] <- tts3

        pvalue <- rep(2, length(tt))
        smT <- TRUE
        smsize <- size
        smsm1 <- sm1
        typesm1 <- unique(smsm1)
        typermd21 <- rmd21
        typermd43 <- rmd43
        typeT <- abs(typermd21*typesm1[, 1]*typesm1[, 4] -
        typermd43*typesm1[, 2]*typesm1[, 3])
        typesize <- round(rowSums(typesm1))
        size1 <- typesm1[, 1]+typesm1[, 2]
        size2 <- typesm1[, 3]+typesm1[, 4]
        message("Exact compute p-values with product binomial distribution.")
        typepvalue <- rep(2, length(typesize))
        for(ii in seq_len(length(typesize))){
            typepvalue[ii] <- probBinom(typeT[ii], size1[ii], size2[ii],
                                        typermd21, typermd43)
    }

    smpvalue <- classifypvalue(typesm1[, 1], typesm1[, 2], typesm1[, 3], 
                               typesm1[, 4], smsm1[, 1], smsm1[, 2],
                               smsm1[, 3], smsm1[, 4],typepvalue, 
                               length(typesm1[, 1]),length(smsm1[, 1]), 
                               pvalue=rep(0, length(smsm1[, 1])))

    pvalue <- smpvalue
    pall[kk[, 4] != 0] <- pvalue
    }

    endtime <- proc.time()
    spendtime <- endtime-starttime
    
    if(!is.null(reportfile)) {
       str <- paste("s1/s2:", fws1s2, 
                    "\n",
                    "s3/s4:", fws3s4
      )
       write(str, reportfile)
       if (length(cpg[kk[, 4] != 0, 1]) != 0) {
           str <- paste("N1(sum of MRE-CpG!=0 ):", N1,
                         "\n",
                         "N2(sum of MRE-CpG!=0 ):", N2,
                         "\n",
                         "N3(sum of MRE-CpG!=0 ):", N3,
                         "\n",
                         "N4(sum of MRE-CpG!=0 ):", N4,
                         "\n",
                         "c1:", rmd21,
                         "\n",
                         "c2:", rmd43)
           write(str, reportfile, append = TRUE)
      }
      str <- paste("Number of windows:",length(pall),
                   "\n",
                   "Number of p<1e-8:",sum(pall<1e-8),
                   "\n",
                   "Number of p<1e-3:",sum(pall<1e-3),
                   "\n",
                   "Spend time:", spendtime)
      write(str, reportfile, append = TRUE)
    }

    cpg[, 2] <- as.integer(cpg[, 2])
    cpg[, 3] <- as.integer(cpg[, 3])
    cpgpq <- cbind(cpg[, seq_len(3)], sm, cpg[, 4], kk[, 4], pall, ts)
    colnames(cpgpq) <- c("chr", "chrSt", "chrEnd", "Medip1", "Medip2", "MRE1",
                         "MRE2", "cg", "mrecg", "pvalue", 'Ts')
    if (!is.null(writefile)) {
        message("Output to writefile.")
        write.table(cpgpq, writefile,sep="\t", quote=FALSE, row.names=FALSE)
    } else {
        message("Return value.")
        return(cpgpq)  
    }
    message("The End.")
    }

---
title: "SIMD Tutorial"
author: "Yan Zhou"
package: SIMD
date: "`r Sys.Date()`"
output: BiocStyle::html_document
vignette: >
    %\VignetteIndexEntry{SIMD Tutorial}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---


# 1 Introduction
This package provides a inferential analysis method 
for detecting differentially expressed CpG sites in MeDIP-seq data. It uses 
statistical framework and EM algorithm, to identify differentially expressed 
CpG sites. The methods on this package are described in the article 
*Methylation-level Inferences and Detection of Differential Methylation 
with Medip-seq Data* by Yan Zhou, Jiadi Zhu, Mingtao Zhao, Baoxue Zhang, 
Chunfu Jiang and Xiyan Yang (2018, pending publication).

SIMD method is developed for jointly analyzing MeDIP-seq and MRE-seq data, 
which are derived from methylated DNA immunoprecipitation (MeDIP) experiments
followed by sequencing (MeDIP-seq) and methyl-sensitive restriction enzymes
experiments for unmethylated CpGs (MRE-seq). We have implemented the
SIMD method via a set of R functions with the computational intensive parts
written in C. We make a R package named SIMD, which is the abbreviation of 
Statistical Inferences with MeDIP-seq Data, and give a tutorial for
the package. The method consist three steps.

Step 1: Data Pre-processing;  

* Calculate the CpG count.   
* Calculate the MRE CpG count.  
* Calculate MeDIP-seq tag count of each site of control and treatment samples.  
* Calculate MRE-seq tag count of each site of control and treatment samples.

Step 2: Calculating p-values of each CpG site by the EM algorithm;

Step 3: Select Significants.

We use a part of a real dataset to illustrate the usage of the SIMD package.
The programs can run under the Linux system and windows 10 system. The
R versions should larger than 3.5.0.

# 2 Preparations
Before installing SIMD package, the user must install three other R pack-
ages, which can be done using the following commands:
```{r, eval=FALSE}
install.packages("BiocManager")
BiocManager::install(c('edgeR', 'statmod','methylMnM'))

library(edgeR)
library(statmod)
library(methylMnM)
```
Next, to install the SIMD package into your R environment, start R and
enter:
```{r, eval=FALSE}
BiocManager::install("SIMD")
```
Then, the SIMD package is ready to load.
```{r}
library(SIMD)
```

# 3 Data format
In order to reproduce the presented SIMD workflow, the package includes the 
example data sets, which is a part of a real data sets, including:  

**all_CpGsite_bin_chr18**,  
**three_mre_cpg**,  
**EM2_H1ESB1_MeDIP_sigleCpG**,  
**EM2_H1ESB2_MeDIP_sigleCpG**,  
**H1ESB1_MRE_sigleCpG**,  
and **H1ESB2_MRE_sigleCpG**, which is included in file example_data.RDdata in 
the data subdirectory of the SIMD package.

The files contain genomic regions from chromosome 18 only, as covered by
short reads obtained from a MeDIP and MRE experiment of human H1ESB1
cells.

All output files are in a .bed format. The input file contain the
following columns.  

* the first coulumn is of type character and contains the chromosome of the
region (e.g. chr1)  
* the second column is of type numeric and contains the start position of
the mapped read  
* the third column is of type numeric and contains the stop position of the
mapped read  
* the fourth column is of type character and contains the strand information
of the mapped read  

For MRE-seq data, we need "+" and "-" strand information in mapping
process, which is general located at the sixth column of the input file. Each 
row represents a mapped read. These information can be extracted from the output
file(s) of common mapping tools.

# 4 Data Pre-processing
The SIMD program requires users to provide the genome-wide MeDIP-seq
and MRE-seq reads and the reference genome. The pre-processing step involves
calculation of MeDIP-seq and MRE-seq count and CpG and MRE-specific count in 
each CpG site. The mainly steps please refer the data pre-processing steps of 
R package MethylMnM. 

In this manual, we use example data located in the data subdirectory of the 
SIMD package, and the example data is processed by MethylMnM package in 
advance. The path is: 
```{r}
datafile <- system.file("extdata", package="methylMnM")
filepath <- datafile[1]
```

The CpG count, MRE-CpG count, MeDIP-seq count and MRE-seq count of each site 
are stored at: 
```{r}
dirwrite <- paste(setwd(getwd()), "/", sep="")
```

Then we compute the number of actual short reads in each CpG site by the 
function of *EMalgorithm()*, which use EM algorithm to infer the actual reads 
by the observation fragments. The results are saved in file *writefile* and 
*reportfile*. We give an example as follows, the data is from data subdirectory 
of the SIMD package:
```{r}
data(example_data)
allcpgfile <- EM_H1ESB1_MeDIP_sigleCpG
readshort <- paste(filepath, "/H1ESB1_MeDIP_18.extended.txt", sep="")
writefile <- paste(dirwrite, "EM2_H1ESB1_MeDIP_sigleCpG.bed", sep="")
reportfile <- paste(dirwrite, "EM2_H1ESB1_MeDIP_sigleCpG_report.bed", sep="")
EMalgorithm(cpgsitefile=readshort, allcpgfile=allcpgfile, category="1",
            writefile=writefile, reportfile=reportfile)
```

# 5 p-values of SIMD test
In order to detect different methylated CpG sites, we should calculate p-value 
of each site. The below codes are calculate p-value of each site with function 
*EMtest()*. The input files which include "datafile", "cpgfile" and 
"mrecpgfile" are should have been generated by Step 1. The output file 
"writefile" will owneleven columns, that is, "*chr*", "*chrSt*","*chrEnd*",
"*Medip1*","*Medip2*", "*MRE1*", "*MRE2*", "*cg*","*mrecg*","*pvalue*","*Ts*". 
We also output a reportfile which will include parameters "*s1/s2*"; "*s3/s4*"; 
"*N1*"; "*N2*"; "*N3*"; "*N4*"; "*c1*"; "*c2*" and "*Spend time*".

```{r}
data(example_data)
data1 <- EM2_H1ESB1_MeDIP_sigleCpG
data2 <- EM2_H1ESB2_MeDIP_sigleCpG
data3 <- H1ESB1_MRE_sigleCpG
data4 <- H1ESB2_MRE_sigleCpG
datafile <- cbind(data1,data2,data3,data4)
allcpg <- all_CpGsite_bin_chr18
mrecpg <- three_mre_cpg
dirwrite <-paste(setwd(getwd()), "/", sep="")

writefile <- paste(dirwrite, "pval_EM_H1ESB1_H1ESB21.bed", sep="")
reportfile <- paste(dirwrite, "report_pvalH1ESB1_H1ESB21.bed", sep="")

EMtest(datafile=datafile, chrstring=NULL, cpgfile=allcpg,mrecpgfile=mrecpg, 
       writefile=writefile, reportfile=reportfile,mreratio=3/7, psd=2, 
       mkadded=1, f=1)
```

# 6 Select Significants
After getting p-values, we choose differentially expressed methylated CpG sites
with p-values. The input file is the file which have been generated by Step 2. 
Then we assume the sites to be differentially expressed methylated CpGs when
p-values less than pre-setting cutoffs, such as $10^{-3}$ or $10^{-5}$.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/emalgth.R
\name{emalgth}
\alias{emalgth}
\title{Calculate the probability on condition that the sums equal to 1.}
\usage{
emalgth(X)
}
\arguments{
\item{X}{A matrix about X, the elements in X takes values on {0,1} and
satisfy the sums of each row equal to 1.}
}
\value{
y1 The probability when sums equal to 1.
}
\description{
Calculate the probability on condition that only a single CpG 
contributes to a short read.
}
\examples{
set.seed(123)
d <- matrix(0, nrow=200, ncol=50)
random_num <- sample(1:50, 200, replace=TRUE)
for(i in 1:nrow(d)){
    d[i,random_num[i]]<-1
}
result <- emalgth(d)
head(result)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/EMtest.R
\name{EMtest}
\alias{EMtest}
\title{Inferring the methylation expression level of single sites.}
\usage{
EMtest(datafile = NULL, chrstring = NULL, cpgfile, mrecpgfile = NULL,
  writefile = NULL, reportfile = NULL, mreratio = 3/7, psd = 2,
  mkadded = 1, f = 1)
}
\arguments{
\item{datafile}{The files of sample. (datafile should be cbind(data1,data2,
data3,data4), where data1 and data2 are Medip-seq data, data3 and data4 are
MRE-seq data).}

\item{chrstring}{The chromosome should be test.}

\item{cpgfile}{The file of all CpG number.}

\item{mrecpgfile}{The file of MRE-CpG number(If NULL, mrecpgfile will equal
to cpgfile).}

\item{writefile}{The path of file of output result. (If writefile=NULL,
there will return the results back to main program)}

\item{reportfile}{The path of output results of the number of bin, total
reads before processing and total reads after processing.}

\item{mreratio}{The ratio of total unmethylation level with total
methylation level (Defaulted mreratio is 3/7).}

\item{psd}{The parameters of pseudo count, which pseudo count added to
Medip-seq and MRE-seq count.}

\item{mkadded}{Added to all CpG and MRE CpG (We set psd=2 and mkadded=1 as
defaulted for robust).}

\item{f}{Adjustment weight, default to 1.}
}
\value{
values or file The output file "writefile" will own eleven columns,
that is, "chr", "chrSt", "chrEnd", "Medip1", "Medip2", "MRE1", "MRE2",
"cg","mrecg","pvalue" and "Ts". We also output a report file which will
include parameters "s1/s2", "s3/s4", "N1", "N2", "N3", "N4", "c1",
"c2", "Number of windows" and "Spend time".
}
\description{
Using statistical framework and EM algorithm to infer the
methylation expression level of single sites.
}
\examples{
data(example_data)
data1 <- EM2_H1ESB1_MeDIP_sigleCpG
data2 <- EM2_H1ESB2_MeDIP_sigleCpG
data3 <- H1ESB1_MRE_sigleCpG
data4 <- H1ESB2_MRE_sigleCpG
datafile <- cbind(data1, data2, data3, data4)
allcpg <- all_CpGsite_bin_chr18
mrecpg <- three_mre_cpg
dirwrite <- paste(setwd(getwd()), "/", sep="")
writefile <- paste(dirwrite, "pval_EM_H1ESB1_H1ESB21.bed", sep="")
reportfile <- paste(dirwrite, "report_pvalH1ESB1_H1ESB21.bed", sep="")
EMtest(datafile=datafile, chrstring=NULL, cpgfile=allcpg,
       mrecpgfile=mrecpg, writefile=writefile, reportfile=reportfile,
       mreratio=3/7, psd=2, mkadded=1, f=1)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/EMalgorithm.R
\name{EMalgorithm}
\alias{EMalgorithm}
\title{EM algorithm to infer CpG sites.}
\usage{
EMalgorithm(cpgsitefile, allcpgfile, category = "1", writefile = NULL,
  reportfile = NULL)
}
\arguments{
\item{cpgsitefile}{The path of file to store CpG site.}

\item{allcpgfile}{The file to store CpG sites.}

\item{category}{Default to "1".}

\item{writefile}{The path of output results. (If writefile=NULL, there will
return the results back to main program.)}

\item{reportfile}{The path of output results.}
}
\value{
values or file If writefile is NULL, then return the values of
results,otherwise output to write file.
}
\description{
Using EM algorithm to infer the real number of CpG sites.
}
\examples{
datafile <- system.file("extdata", package="methylMnM")
data(example_data)
filepath <- datafile[1]
allcpgfile <- EM_H1ESB1_MeDIP_sigleCpG
dirwrite <- paste(setwd(getwd()), "/", sep="")
readshort <- paste(filepath, "/H1ESB1_MeDIP_18.extended.txt", sep="")
writefile <- paste(dirwrite, "EM2_H1ESB1_MeDIP_sigleCpG.bed", sep="")
reportfile <- paste(dirwrite, "EM2_H1ESB1_MeDIP_sigleCpG_report.bed", sep="")
f <- EMalgorithm(cpgsitefile=readshort, allcpgfile=allcpgfile, category="1",
                 writefile=writefile, reportfile=reportfile)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/probBinom.R
\name{probBinom}
\alias{probBinom}
\title{Compute P-values for Medip-seq and MRE-seq data.}
\usage{
probBinom(t, size1, size2, c1, c2)
}
\arguments{
\item{t}{The real value for random variable according to dataset.}

\item{size1}{The sum of Medip-seq real reads of the each CpG site for
control and treatment sample.}

\item{size2}{The sum of MRE-seq real reads of the each CpG site for control
and treatment sample.}

\item{c1}{The scaling factor for MeDip-seq data.}

\item{c2}{The scaling factor for MRE-seq data.}
}
\value{
p The P-values for testing the methylation expression levels for each
CpG sites.
}
\description{
Compute P-values.
}
\examples{
set.seed(1234)
t <- 0.1
size1 <- sample(1:1000, 1, replace=TRUE)
size2 <- sample(1:1000, 1, replace=TRUE)
c1 <- 1
c2 <- 2
result <- probBinom(t, size1, size2, c1, c2)
}

\name{SIMD-package}
\alias{SIMD-package}

\docType{package}
\title{
    A method to infer the methylation expression level for each CpG sites.
}
\description{
    SIMD is a package to infer the methylation expression level for each CpG
    sites.The main idea of SIMD is that by using statistical inference to with
    Medip-seq data method to infer the methylation level.
}

\author{
    Zhou Yan
    Maintainer:Zhou Yan <zhouy1016@szu.edu.cn>
}
\references{
    Zhou Y. (2018). Methylation-level inferences and detection of differential
methylation with Medip-seq data.}
\keyword{ package }

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classifypvalue.R
\name{classifypvalue}
\alias{classifypvalue}
\title{calculate P-value in code EMtest.}
\usage{
classifypvalue(type1, type2, type3, type4, sm1chring1, sm1chring2, sm1chring3,
  sm1chring4, p, typelength, sm1chringlength, pvalue = rep(0,
  length(sm1chring1)))
}
\arguments{
\item{type1}{The first colum of the first matrix.}

\item{type2}{The second colum of the first matrix.}

\item{type3}{The third colum of the first matrix.}

\item{type4}{The fourth colum of the first matrix.}

\item{sm1chring1}{The first colum of the second matrix.}

\item{sm1chring2}{The second colum of the second matrix.}

\item{sm1chring3}{The third colum of the second matrix.}

\item{sm1chring4}{The forth colum of the second matrix.}

\item{p}{P-value.}

\item{typelength}{The nrows of the first matrix.}

\item{sm1chringlength}{The nrows of the second matrix.}

\item{pvalue}{A vector, the length equals to the nrows of the second matrix.}
}
\value{
The probability.
}
\description{
calculate P-value in code EMtest.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/emalgth1.R
\name{emalgth1}
\alias{emalgth1}
\title{Calculate the probability on condition that the sums more than 1.}
\usage{
emalgth1(X)
}
\arguments{
\item{X}{A matrix about X, the elements in X takes values on {0,1} and
satisfy the sums of each row more than 1.}
}
\value{
y1 The probability when sums more than 1.
}
\description{
Calculate the probability on condition that at least a CpG 
contributes to a short read.
}
\examples{
set.seed(123)
d <- matrix(0, nrow=200, ncol=50)
random_num <- sample(1:10, 200, replace=TRUE)
for(i in 1:nrow(d)){
    temp <- sample(1:50, random_num[i], replace=FALSE)
    d[i,temp] <- 1
}
result <- emalgth1(d)
head(result)
}

\name{three_mre_cpg}
\docType{data}
\alias{three_mre_cpg}
\title{A simulation dataset of MRE CpG sites.}
\description{
    This data set gives 2000 CpG sites which include the chromosome of the
region, the start and the stop position of the MRE CpG sites.

}
\usage{three_mre_cpg}

\format{A data.frame containing 2000 MRE CpG sites.}
\source{Zhang, B., Zhou, Y., et al. (2013). Functional DNA methylation
differences between tissues, cell types, and across individuals discovered
using the M&M algorithm. Genome Research. 23: 1522-1540.
}
\references{
    Zhou Y. (2018). Methylation-level Inferences and Detection of Differential
Methylation with Medip-seq Data.
}
\keyword{datasets}
\keyword{ internal }
